<!-- eslint-disable vue/multi-word-component-names -->
<template>
  <div class="d-flex flex-column align-items-center">
    <div class="d-flex form-container">
      <div class="registration-form p-4 border rounded shadow">
        <h1>Register</h1>
        <b-form @submit.prevent="submitUser">
          <b-form-group label="Name">
            <b-form-input
              v-model="name"
              :disabled="submitting"
              :state="$v.name.$dirty ? ($v.name.$invalid ? false : true) : null"
              placeholder="Enter your name"
              @change="$v.name.$touch"
            />
          </b-form-group>
          <b-form-group label="Username">
            <b-form-input
              v-model="username"
              :disabled="submitting"
              :state="$v.username.$dirty ? ($v.username.$invalid ? false : true) : null"
              placeholder="Enter a username"
              @change="$v.username.$touch"
            />
            <b-form-text v-if="!$v.username.$dirty || !$v.username.$invalid" />
            <b-form-invalid-feedback v-else-if="!$v.username.required">
              Field is required.
            </b-form-invalid-feedback>
            <b-form-invalid-feedback v-else-if="!$v.username.maxLength || !$v.username.minLength">
              Field must have between 4 and 64 characters.
            </b-form-invalid-feedback>
          </b-form-group>
          <b-form-group label="Email">
            <b-form-input
              v-model="email"
              :disabled="submitting"
              :state="$v.email.$dirty ? ($v.email.$invalid ? false : true) : null"
              placeholder="Enter your email address"
              @change="$v.email.$touch"
            />
            <b-form-text v-if="!$v.email.$dirty || !$v.email.$invalid" />
            <b-form-invalid-feedback v-else-if="!$v.email.required">
              Field is required.
            </b-form-invalid-feedback>
            <b-form-invalid-feedback v-else-if="!$v.email.email">
              Field must be a valid email address.
            </b-form-invalid-feedback>
          </b-form-group>
          <b-form-group label="Password">
            <b-form-input
              v-model="password"
              :disabled="submitting"
              :state="$v.password.$dirty ? ($v.password.$invalid ? false : true) : null"
              placeholder="Enter a password"
              type="password"
              @change="$v.password.$touch"
            />
            <b-form-text v-if="!$v.password.$dirty || !$v.password.$invalid">
              Your password must contain at least 8 characters.
            </b-form-text>
            <b-form-invalid-feedback v-else-if="!$v.password.required">
              Field is required.
            </b-form-invalid-feedback>
            <b-form-invalid-feedback v-else-if="!$v.password.minLength || !$v.password.maxLength">
              Field must have between 8 and 256 characters.
            </b-form-invalid-feedback>
            <b-form-invalid-feedback v-else-if="!$v.password.specialCharacters">
              Field must contain at least one number and one uppercase
              letter.
            </b-form-invalid-feedback>
          </b-form-group>
          <b-form-group label="Repeat Password">
            <b-form-input
              v-model="repeatPassword"
              :disabled="submitting"
              :state="$v.repeatPassword.$dirty ? ($v.repeatPassword.$invalid ? false : true) : null"
              placeholder="Enter the same password"
              type="password"
              @change="$v.repeatPassword.$touch"
            />
            <b-form-text v-if="!$v.repeatPassword.$dirty || !$v.repeatPassword.$invalid" />
            <b-form-invalid-feedback v-else-if="!$v.repeatPassword.required">
              Field is required.
            </b-form-invalid-feedback>
            <b-form-invalid-feedback v-else-if="!$v.repeatPassword.sameAsPassword">
              Field doesn't match password.
            </b-form-invalid-feedback>
          </b-form-group>
          <hr>
          <b-button
            :disabled="$v.$invalid || submitting"
            block
            type="submit"
            variant="success"
          >
            Register
          </b-button>
          <b-button
            :disabled="submitting"
            :to="{ name: 'login', query: $route.query }"
            block
            variant="primary"
          >
            Already have an account?
          </b-button>
        </b-form>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
/* eslint-disable no-alert */
import Vue from 'vue';
import {
  email, maxLength, minLength, required, sameAs,
} from 'vuelidate/lib/validators';

import { REGISTER } from '@/store/actions';

export default Vue.extend({
  beforeRouteLeave(to, from, next) {
    if (this.$v.$anyDirty && !this.submitted) {
      const confirmed = window.confirm('You have unsaved changes, do you really want to leave?');
      if (confirmed) {
        next();
      }
      return;
    }
    next();
  },

  data() {
    return {
      email: '',
      name: '',
      password: '',
      submitted: false,
      submitting: false,
      repeatPassword: '',
      username: '',
    };
  },

  validations: {
    email: {
      email,
      required,
    },
    name: {
      required,
    },
    password: {
      minLength: minLength(8),
      maxLength: maxLength(256),
      specialCharacters: (password) => {
        if (!/[A-Z]/.test(password)) {
          return false;
        }
        if (!/\d/.test(password)) {
          return false;
        }
        return true;
      },
      required,
    },
    repeatPassword: {
      sameAsPassword: sameAs('password'),
      required,
    },
    username: {
      required,
      minLength: minLength(4),
      maxLength: maxLength(64),
    },
  },

  methods: {
    async submitUser() {
      this.submitting = true;
      try {
        await this.$store.dispatch(REGISTER, {
          user: {
            name: this.name,
            email: this.email,
            username: this.username,
            password: this.password,
          },
        });
        this.submitting = false;
        this.submitted = true;
        this.$router.push({ name: 'login', query: this.$route.query });
      } catch (errors) {
        if (errors[0].status === 409) {
          // This is most likely a duplicate username
          window.alert('This username is already in use, please choose a different one.');
        }
        this.submitting = false;
      }
    },
  },
});
</script>

<style scoped>
.form-container {
  margin-top: 70px;
}
.registration-description {
  margin-right: 1em;
}
.registration-description {
  font-family: Arial, Helvetica, sans-serif;
  font-weight: bolder;
  font-variant: small-caps;
  font-size: 4em;
  color: darkslategray;
}
.registration-form {
  width: 400px;
}
</style>
